#include <catch.h>

void inc_p(int* p)
{
    *p += 1;
}

TEST_CASE("C-style increment")
{
    int x = 0;
    inc_p(&x);
    CHECK( x == 1 );
}

void inc_r(int& r)
{
    r += 1;
}

TEST_CASE("C++-style increment")
{
    int x{0};
    inc_r(x);
    CHECK( x == 1 );
}

void swap_p(int* p, int* q) {
    int temp = *p;
    *p = *q;
    *q = temp;
}

TEST_CASE("C-style swap")
{
    int x = 3, y = 4;
    swap_p(&x, &y);
    CHECK( x == 4 );
    CHECK( y == 3 );
}

void swap_r(int& r, int& s)
{
    int temp = r;
    r = s;
    s = temp;
}

TEST_CASE("C++-style swap")
{
    int x = 3, y = 4;
    swap_r(x, y);
    CHECK( x == 4 );
    CHECK( y == 3 );
}

void broken_swap_r(int& r, int& s)
{
    int& temp = r;
    r = s;
    s = temp;
}

TEST_CASE("broken swap")
{
    int x = 3, y = 4;
    broken_swap_r(x, y);
    CHECK( x == 4 );
    CHECK( y == 4 );
}

